<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CDRRepository.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">ProyectoArquitectura</a> &gt; <a href="index.source.html" class="el_package">data</a> &gt; <span class="el_source">CDRRepository.java</span></div><h1>CDRRepository.java</h1><pre class="source lang-java linenums">package data;
import java.util.ArrayList;
import java.util.List;
import Entities.Bill;
import Entities.CDR;
import Entities.Phone_Number;

<span class="fc" id="L8">public class CDRRepository implements ICDRRepository{</span>

<span class="fc" id="L10">	List&lt;CDR&gt; listCDRsCalculated = new ArrayList&lt;&gt;(); </span>
<span class="fc" id="L11">	List&lt;CDR&gt; listCDRsNotCalculated = new ArrayList&lt;&gt;(); </span>
<span class="fc" id="L12">	CurrentDate currentDates = new CurrentDate();</span>
	private List&lt;CDR&gt; listResult ;
	
	public List&lt;CDR&gt; getCalculatedDateFromCDRs() {
<span class="fc" id="L16">        listResult = new ArrayList&lt;&gt;();</span>
<span class="fc" id="L17">        String currentDate = null;</span>
<span class="fc" id="L18">        String currentHour = null;</span>
<span class="fc bfc" id="L19" title="All 2 branches covered.">        for (CDR cdr : listCDRsCalculated) {</span>
<span class="pc bpc" id="L20" title="1 of 4 branches missed.">        	if (!cdr.gethourTarification().equals(currentHour) || !cdr.getdateTarification().equals(currentDate))</span>
        	{
<span class="fc" id="L22">        		currentDate = cdr.getdateTarification();</span>
<span class="fc" id="L23">        		currentHour = cdr.gethourTarification();</span>
<span class="fc" id="L24">        		listResult.add(cdr);</span>
        	}
    	}
<span class="fc" id="L27">		return listResult;</span>
	}
	
	public List&lt;CDR&gt; getCDRFilterByDateAndHour(String currentDate, String currentHour) {
<span class="fc" id="L31">        listResult = new ArrayList&lt;&gt;();</span>
<span class="fc bfc" id="L32" title="All 2 branches covered.">        for (CDR cdr : listCDRsCalculated) {</span>
<span class="pc bpc" id="L33" title="1 of 4 branches missed.">        	if (cdr.gethourTarification().equals(currentHour) &amp;&amp; cdr.getdateTarification().equals(currentDate))</span>
        	{
<span class="fc" id="L35">        		listResult.add(cdr);</span>
        	}
    	}
<span class="fc" id="L38">        return listResult;</span>
    }
	
	@Override
	public void loadCDRs(List&lt;CDR&gt; listCDRs) {
<span class="fc" id="L43">		listCDRsCalculated.clear();</span>
<span class="fc" id="L44">		listCDRsCalculated.addAll(listCDRs);</span>
<span class="fc" id="L45">	}</span>
	
	@Override
	public List&lt;CDR&gt; getCDRsCalculated() {
<span class="fc" id="L49">		return listCDRsCalculated;</span>
	}

	@Override
	public List&lt;CDR&gt; getCDRsNotCalculated() {
<span class="fc" id="L54">		return listCDRsNotCalculated;</span>
	}
	
	@Override
	public void registerCDR(CDR cdr) {
<span class="fc" id="L59">		listCDRsNotCalculated.add(cdr);</span>
<span class="fc" id="L60">	}</span>

	@Override
	public void showAllCDRs() {
<span class="fc bfc" id="L64" title="All 2 branches covered.">		for (CDR cdr : listCDRsCalculated) {</span>
<span class="fc" id="L65">			cdr.showInformation();</span>
		}
<span class="fc bfc" id="L67" title="All 2 branches covered.">		for (CDR cdr : listCDRsNotCalculated) {</span>
<span class="fc" id="L68">			cdr.showInformation();</span>
		}
<span class="fc" id="L70">	}</span>

	@Override
	public List&lt;CDR&gt; calculateRateForOne(Phone_Number number) {
<span class="fc" id="L74">		List&lt;CDR&gt; result = searchCDRs(number);</span>
<span class="fc bfc" id="L75" title="All 2 branches covered.">		for (CDR cdr : result) {</span>
<span class="fc" id="L76">			cdr.setCallCost(cdr.calculteCallCost(number));</span>
		}
<span class="fc" id="L78">		return result;</span>
	}

	@Override
	public List&lt;CDR&gt; calculateRateForAll(List&lt;Phone_Number&gt; listPhoneNumber) {
<span class="fc" id="L83">		String currentHour = currentDates.getHour();</span>
<span class="fc" id="L84">		String currentDate = currentDates.getDate();</span>
<span class="fc bfc" id="L85" title="All 2 branches covered.">		for(CDR register : listCDRsNotCalculated)</span>
		{
<span class="fc" id="L87">			Phone_Number phone = searchPhone(register.getOriginNumber(),listPhoneNumber);</span>
<span class="fc" id="L88">			register.setCallCost(register.calculteCallCost(phone));</span>
<span class="fc" id="L89">			register.SetdateTarification(currentDate);</span>
<span class="fc" id="L90">			register.SethourTarification(currentHour);</span>
		}
<span class="fc" id="L92">		return listCDRsNotCalculated;</span>
	}

	public Phone_Number searchPhone(int numberOrigin,List&lt;Phone_Number&gt; listPhoneNumber) {
<span class="fc bfc" id="L96" title="All 2 branches covered.">		for(Phone_Number phone : listPhoneNumber)</span>
		{
<span class="fc bfc" id="L98" title="All 2 branches covered.">			if(phone.getTelephone() == numberOrigin)</span>
<span class="fc" id="L99">				return phone;</span>
		}
<span class="fc" id="L101">		return null;</span>
	}
	
	
	private List&lt;CDR&gt; searchCDRs(Phone_Number number){
<span class="fc" id="L106">        listResult = new ArrayList&lt;&gt;();</span>
<span class="fc bfc" id="L107" title="All 2 branches covered.">		for (CDR cdr : listCDRsNotCalculated) {</span>
<span class="pc bpc" id="L108" title="1 of 2 branches missed.">			if (cdr.getOriginNumber() ==  number.getTelephone()) {</span>
<span class="fc" id="L109">				listResult.add(cdr);</span>
			}
		}
<span class="fc" id="L112">		return listResult;</span>
	}

	@Override
	public void registerCDRs(String cdrs) {
<span class="fc" id="L117">		int originNumber = 0;</span>
<span class="fc" id="L118">		int destinationNumber = 0;</span>
<span class="fc" id="L119">		String durationCall = null;</span>
<span class="fc" id="L120">		String date = null;</span>
<span class="fc" id="L121">		String hour = null;</span>
<span class="fc" id="L122">		String[] parts = cdrs.split(&quot;\\r?\\n|;&quot;);</span>
		
<span class="fc" id="L124">		int i=0;</span>
<span class="fc bfc" id="L125" title="All 2 branches covered.">		while (i&lt;parts.length) {</span>
<span class="fc" id="L126">			originNumber=Integer.parseInt(parts[i]);i++;</span>
<span class="fc" id="L127">			destinationNumber=Integer.parseInt(parts[i]);i++;</span>
<span class="fc" id="L128">			durationCall=parts[i];i++;</span>
<span class="fc" id="L129">			date=parts[i];i++;</span>
<span class="fc" id="L130">			hour=parts[i];i++;</span>
<span class="fc" id="L131">			CDR newCDR = new CDR(originNumber, destinationNumber, durationCall, date, hour);</span>
<span class="fc" id="L132">			listCDRsNotCalculated.add(newCDR);</span>
		}
<span class="fc" id="L134">	}</span>

	@Override
	public void cleanListCDRsNotCalculated() {
<span class="fc" id="L138">		listCDRsNotCalculated.clear();</span>
<span class="fc" id="L139">	}</span>

	@Override
	public Bill getRateForClient(int phoneNumber, String date) {
<span class="fc" id="L143">		Bill newBill = new Bill(phoneNumber, date, 0);</span>
<span class="fc bfc" id="L144" title="All 2 branches covered.">		for (CDR cdr : listCDRsCalculated) {</span>
<span class="fc bfc" id="L145" title="All 2 branches covered.">			if (validateNumberAndDate(phoneNumber,date,cdr))</span>
			{
<span class="fc" id="L147">				newBill.setcost(newBill.getcost()+cdr.getCallCost());</span>
			}
		}
<span class="fc" id="L150">		return newBill;</span>
	}
	
	private boolean validateNumberAndDate(int phoneNumber, String date,CDR cdr) {
<span class="pc bpc" id="L154" title="1 of 4 branches missed.">		if (phoneNumber == cdr.getOriginNumber()  &amp;&amp; date.contains(getMonthFromDate(cdr.getdateTarification()))) {</span>
<span class="fc" id="L155">			return true;</span>
	  	} else {
<span class="fc" id="L157">	  		return false;</span>
	  	}
	}
	
	private String getMonthFromDate(String date) {
<span class="fc" id="L162">		String[] str = date.split(&quot;/&quot;);</span>
<span class="fc" id="L163">		int month = Integer.parseInt(str[1]);</span>
<span class="fc" id="L164">		return String.valueOf(month);</span>
	}


	@Override
	public void setTarificateDate(String date) {
<span class="fc bfc" id="L170" title="All 2 branches covered.">		for (CDR cdr : listCDRsCalculated) {</span>
<span class="fc" id="L171">			cdr.SetdateTarification(date);</span>
		}
<span class="fc" id="L173">	}</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.3.201901230119</span></div></body></html>